#version 120
#extension GL_EXT_gpu_shader3 : enable

attribute float pointSize;
//uniform vec2 screenSize;
uniform vec4 viewport;
uniform float baseDistance;
uniform int dissolveMode;

varying vec4 position;
varying vec2 center;
varying vec2 relCenter;
varying float cosPhi;
varying float sinPhi;
varying float coscosPhi;
varying float sinsinPhi;
varying float sincosPhi;
varying float B2;//radiusFactor2;
varying float radius2;

varying vec2 ensembleParamA;
varying float ensembleParamB;

void main(void)
{
    position = gl_ModelViewMatrix * gl_Vertex;
    gl_FrontColor = gl_Color;

    gl_Position = ftransform();

    //float xydistance = sqrt(gl_Position.x * gl_Position.x + gl_Position.y * gl_Position.y);
    //float theta = atan(xydistance/gl_Position.w);
    
    //float factor = cos(theta) * cos(theta);
    //radiusFactor2 = factor * factor;

    //float thetax = atan(gl_Position.x / gl_Position.w);

    if (gl_Position.w == 0 || position.z >= 0){
	radius2 = 0;
	gl_PointSize = 0;
	return;
    }

    float thetax = atan(position.x / position.z);
    float factorx = 1.0/(cos(thetax)+0.00001);

    //float thetay = atan(gl_Position.y / gl_Position.w);
    float thetay = atan(position.y / position.z);
    float factory = 1.0/(cos(thetay)+0.00001);

    float factor = 1.0 / (1.0+sqrt((factorx-1)*(factorx-1)+(factory-1)*(factory-1)));
    //radiusFactor2 = factor * factor;
    B2 = factor * factor;

    float radius;
    if (baseDistance != 0){
	radius = pointSize / gl_Position.w / 2 * baseDistance / factor;
    }
    else{
	radius = pointSize / 2 / factor;
    }
    
    //if (radius > 5) radius = 5;
    gl_PointSize = radius * 2;
    radius2 = radius * radius;
    
    center = vec2((gl_Position.x/gl_Position.w * viewport[2] + viewport[2])/2 + viewport[0],
		  (gl_Position.y/gl_Position.w * viewport[3] + viewport[3])/2 + viewport[1]);

    relCenter = vec2(center.x - viewport[0] - viewport[2] * 0.5,
		     center.y - viewport[1] - viewport[3] * 0.5);

    float r = length(relCenter);

    if (r == 0){
	cosPhi = 1;
	sinPhi = 0;
	coscosPhi = 1;
	sinsinPhi = 0;
	sincosPhi = 0;
	return;
    }

    cosPhi = relCenter.x / r;
    sinPhi = relCenter.y / r;
    coscosPhi = cosPhi * cosPhi;
    sinsinPhi = sinPhi * sinPhi;
    sincosPhi = sinPhi * cosPhi;
}
