
#version 120
#extension GL_EXT_gpu_shader3 : enable

uniform sampler2D textureImage;
uniform int textureMode;
uniform int fogMode;
uniform int useTexAlpha;
uniform int dissolveMode;

varying float diffuseTotal;
varying float specularTotal;

varying vec3 position;

uniform vec2 ensembleParamA;
uniform float ensembleParamB;
uniform vec2 ensembleParamC;

uniform float projInv11;
uniform float projInv15;

//##FUNC_SMOOTHCLIPPING##

//##FUNC_ENSEMBLE_DITHERING##

//##FUNC_FOG_EFFECT##

void main (void)
{
    vec4 texColor = vec4(1.0,1.0,1.0,1.0); 
    if (textureMode == 1)
	texColor = texture2D(textureImage, gl_TexCoord[0].st);

    float alpha = gl_FrontLightProduct[0].ambient[3];
    if (useTexAlpha == 1){
	alpha *= texColor[3];
	if (alpha == 0) discard;
    }

    //##APPLY_SMOOTHCLIPPING##

    //##APPLY_ENSEMBLE_DITHERING##

    //if (alpha > 1.0) alpha = 1.0;
    if (alpha > 1.0){ 
	texColor[0] *= alpha;
	texColor[1] *= alpha;
	texColor[2] *= alpha; 
	alpha = 1.0;
    }

    gl_FragColor = gl_FrontLightProduct[0].ambient + 
	gl_FrontMaterial.diffuse * diffuseTotal +
	gl_FrontMaterial.specular * specularTotal;
    gl_FragColor *= texColor;
    
    //##APPLY_FOG_EFFECT##

    gl_FragColor[3] = alpha;
}
